package com.esignlive.guidance.forum;

import static com.silanis.esl.sdk.builder.PackageBuilder.newPackageNamed;
import static com.silanis.esl.sdk.builder.SignerBuilder.newSignerWithEmail;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import com.silanis.esl.sdk.DocumentPackage;
import com.silanis.esl.sdk.DocumentType;
import com.silanis.esl.sdk.EslClient;
import com.silanis.esl.sdk.ExtractionType;
import com.silanis.esl.sdk.PackageId;
import com.silanis.esl.sdk.builder.DocumentBuilder;

public class _12_16 {
	private String API_KEY = "your_api_key";
	private String API_URL = "https://sandbox.esignlive.com/api";

	public void execute() throws IOException {
		EslClient eslClient = new EslClient(API_KEY, API_URL);

		URL url = new URL("https://developer.esignlive.com/app/uploads/DocumentExtractionOptional_Signature.pdf");
		InputStream in = url.openStream();
		
		DocumentPackage newPackage = newPackageNamed("Document Extraction + Optional Signature")
				.withSigner(newSignerWithEmail("signer1@mailinator.com")
						.withFirstName("signer1 first name")
						.withLastName("signer1 second name")
						.withCustomId("Signer1"))
				.withDocument(DocumentBuilder.newDocumentWithName("doc1")
						.fromStream(in, DocumentType.PDF)
						.enableExtraction()
						.withExtractionType(ExtractionType.ACROFIELDS))
				.build();

		in.close();
		
		PackageId createPackageOneStep = eslClient.createPackageOneStep(newPackage);
		System.out.println(createPackageOneStep);
	}

	public static void main(String[] args) {
		try {
			new _12_16().execute();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
